module deposit_mod
  use sep
  use model_type_mod
  implicit none
  contains
  subroutine deposit_layer(in,out,icom)
    type(vel_model) :: in,out
    integer :: ithick,i2,i3,i1,ifound,icom,iold,nsmooth,ii
    character(len=256) :: tmp,v1
    real :: vel,layer,dev_layer,dev_pos,beg,delta,vu,rnd,dev_p,rect,layer_rand,luse
    real,allocatable :: layv(:),pp(:,:,:),pt(:,:,:)
    real ::sc
    real,allocatable :: tot(:,:)
    integer :: nmx
    
      call cat_it(v1,"thick_",icom) ;call from_param(v1,ithick)
      call cat_it(v1,"layer_rand",icom); call from_param(v1,layer_rand,0.)
      call cat_it(v1,"layer_",icom); call from_param(v1,layer,99999.)
      call cat_it(v1,"prop_",icom) ;call from_param(v1,vel)
      call cat_it(v1,"dev_layer_",icom); call from_param(v1,dev_layer,0.)
      call cat_it(v1,"dev_pos_",icom); call from_param(v1,dev_pos,0.)
            call cat_it(v1,"nsmooth_",icom); call from_param(v1,nsmooth,8)
    call create_new_model(in,out,ithick,0)
    allocate(layv(out%n1))
    nmx=max(out%n1,out%n2,out%n3)+2*nsmooth
    allocate(tot(nmx,nmx))
    iold=0
    vu=vel
    call random_number(rnd)
    luse=layer*(1+(.5+rnd)*layer_rand)
    do i1=1,out%n1
      ii=(i1-iold)*out%d1/luse
      if(ii/=iold) then
        call random_number(rnd)
        vu=(1.+(rnd-.5)*dev_layer)*vel
        iold=ii
        luse=layer*(1+(.5+rnd)*layer_rand)
      end if
      layv(i1)=vu
    end do
    allocate(pp(out%n1+nsmooth*2,out%n2+nsmooth*2,out%n3+nsmooth*2),pt(out%n2+nsmooth*2,out%n2+nsmooth*2,out%n3+nsmooth*2))
    do i3=1,out%n3+nsmooth*2
           call random_number(tot)
      !$OMP PARALLEL DO default(shared) private(i2,i1)
      do i2=1,out%n2+nsmooth*2
        do i1=1,out%n1+nsmooth*2
           pp(i1,i2,i3)=((tot(i1,i2)-.5))
        end do
      end do
    end do
    pt=pp
        !$OMP PARALLEL DO default(shared) private(i3,i1)
    do i3=1,out%n3+nsmooth*2
      do i1=1,out%n1+nsmooth*2
         tot(i1,i3)=sum(pp(i1,1:nsmooth*2+1,i3))
         pt(i1,nsmooth+1,i3)=tot(i1,i3)/(nsmooth*2+1)
      end do
    end do
        !$OMP PARALLEL DO default(shared) private(i2,i1,i3)
    do i3=1,out%n3+nsmooth*2
      do i2=nsmooth+2,out%n2+nsmooth
        do i1=1,out%n1+nsmooth*2
          tot(i1,i3)=tot(i1,i3)-pp(i1,i2-nsmooth-1,i3)+pp(i1,i2+nsmooth,i3)
          pt(i1,i2,i3)=tot(i1,i3)/(nsmooth*2+1)
        end do
      end do
    end do

    pp=pt
    if(1==1) then

    !$OMP PARALLEL DO default(shared) private(i2,i1)
        do i2=1,out%n2+nsmooth*2
      do i1=1,out%n1+nsmooth*2
         tot(i1,i2)=sum(pp(i1,i2,1:nsmooth*2+1))
          pt(i1,i2,nsmooth+1)=tot(i1,i2)/(nsmooth*2+1)
      end do
    end do
      !$OMP PARALLEL DO default(shared) private(i2,i3,i1)
      do i2=1,out%n2+nsmooth*2
        do i3=nsmooth+2,out%n3+nsmooth

        do i1=1,out%n1+nsmooth*2
           tot(i1,i2)=tot(i1,i2)-pp(i1,i2,i3-nsmooth-1)+pp(i1,i2,i3+nsmooth)
          pt(i1,i2,i3)=tot(i1,i2)/(nsmooth*2+1)
        end do
      end do
    end do
    pp=pt
    end if

    !$OMP PARALLEL DO default(shared) private(i2,i3)
    do i3=1,out%n3+nsmooth*2
      do i2=1,out%n2+nsmooth*2
         tot(i2,i3)=sum(pp(1:nsmooth*2+1,i2,i3))
          pt(nsmooth+1,i2,i3)=tot(i2,i3)/(nsmooth*2+1)
      end do
    end do
    !$OMP PARALLEL DO default(shared) private(i1,i2,i3)
    do i3=1,out%n3+nsmooth*2
      do i2=1,out%n2+nsmooth*2
        do i1=nsmooth+2,out%n1+nsmooth
            tot(i2,i3)=tot(i2,i3)-pp(i1-nsmooth-1,i2,i3)+pp(i1+nsmooth,i2,i3)
           pt(i1,i2,i3)=tot(i2,i3)/(nsmooth*2+1)
         end do
      end do
    end do
    pp=pt

    sc=maxval(abs(pp(1+nsmooth:out%n1+nsmooth,1+nsmooth:out%n2+nsmooth,1:nsmooth:out%n3+nsmooth)))
    
    pp=(1+dev_pos/sc*pp)


    deallocate(pt,tot)

    !$OMP PARALLEL DO private(i3,i1,i2,dev_p)
    do i3=1,in%n3
      do i2=1,in%n2
        i1=1
        do while(i1 < out%n1-1 .and. out%layer(i1,i2,i3) ==-1)
          i1=i1+1
        end do
        if(i1==out%n1) call seperr("should not have been able to reach bottom")
        out%vals(1:i1-1,i2,i3)=layv(1:i1-1)*pp(nsmooth+1:i1-1+nsmooth,i2+nsmooth,i3+nsmooth)
        out%layer(1:i1-1,i2,i3)=icom
     end do
   end do
   !$OMP END PARALLEL DO


   deallocate(layv,pp)
 end subroutine
end module
    
