program driver_prog
  use deposit_mod
  use uplift_mod
  use fault_mod
  use erode_mod
  use gauss_mod
  use inplace_mod
  use compact_mod
  integer :: n1,n2,n3
  real :: o1,o2,o3
  real :: d1,d2,d3
  type(vel_model),target :: tmp1,tmp2
  type(vel_model),pointer :: p1,p2,p3
  real :: basement
  integer :: nlayer,ierr
  character(len=128) ::v1,v2
  call sep_init()
  
  if(redin()==0) then
    call from_param("n1",n1,100)
    call from_param("n2",n2,1000)
    call from_param("n3",n3,1000)
    call from_param("o1",o1,0.)
    call from_param("d1",d1,4.)
    call from_param("d2",d2,4.)
    call from_param("d3",d3,4.)
    call from_param("o2",o2,0.)
    call from_param("o3",o3,0.)
    call from_param("basement",basement,5000.)
   call allocate_model(tmp1,n1,o1,d1,n2,o2,d2,n3,o3,d3,basement);
  else
    ierr=sep_get_data_axis_par("in",1,n1,o1,d1,v1)
    ierr=sep_get_data_axis_par("in",2,n2,o2,d2,v1)
    ierr=sep_get_data_axis_par("in",3,n3,o3,d3,v1)
    call allocate_model(tmp1,n1,o1,d1,n2,o2,d2,n3,o3,d3,basement)
    ierr=sreed("in",tmp1%vals,size(tmp1%vals)*4)
  end if
  call from_param("nevents",nlayer)
  p1=>tmp1
  p2=>tmp2
  do i=1,nlayer
    call cat_it(v1,"event",i)
    write(0,*) trim(v1)
    call from_param(v1,v2)
    write(0,*) i,trim(v2)
    if(v2(1:4)=="depo") then
      call deposit_layer(p1,p2,i)
    else if(v2(1:4)=="upli") then
      call uplift_it(p1,p2,i)
    else if(v2(1:4)=="comp") then
      call compact_it(p1,p2,i)
    else if(v2(1:5)=="erode") then
       call erode_it(p1,p2,i)
    else if(v2(1:7)=="fault_p") then
       call fault_it(p1,p2,i)
    else if(v2(1:7)=="fault_c") then
       call fault_curve(p1,p2,i)
    else if(v2(1:5)=="gauss") then
       call gauss_it(p1,p2,i)
    else if(v2(1:5)=="empla") then
       call inplace_it(p1,p2,i)
    else if(v2(1:4)=="skip")then
        call create_new_model(p1,p2,0,0)
    else
      write(0,*) "Unknown method:",trim(v2)
      call seperr("")
    end if
    call clean_model(p1)
    p3=>p1
    p1=>p2
    p2=>p3
  end do
  call write_model("out",p1)


end program