module erode_mod
  use sep
  use model_type_mod
  implicit none
  contains
  
  subroutine erode_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    character(len=256) :: tmp,v1
    call create_new_model(in,out,0,0)
    call cat_it(v1,"erode_type_",icom); call from_param(v1,tmp)
    if(tmp(1:4)=="rive") then 
      call erode_river(out,icom)
    else if(tmp(1:4)=="bowl") then
      call erode_bowl(out,icom)
    else 
      write(0,*) "unknown erode ",trim(tmp)
    end if
  end subroutine

  
  subroutine erode_bowl(out,icom)
    type(vel_model) :: out
    integer :: icom
    integer :: i1,i2,i3
    integer :: t1,t2,t3,ierr
    integer :: b3,e3,b2,e2,ishift
    real :: center3, center2,ax1,ax2,ax3,d2,d3,d1
    real :: scale1,dist
     real :: fill_d,fill_v,p1

    character(len=128) :: tmp,v1
    real :: pi
    
    pi=atan(1.)*4;
        call cat_it(v1,"center3_",icom); call from_param(v1,center3) 
        call cat_it(v1,"center2_",icom); call from_param(v1,center2)
        call cat_it(v1,"depth_",icom); call from_param(v1,ax1)
        call cat_it(v1,"width2_",icom); call from_param(v1,ax2)
        call cat_it(v1,"width3_",icom); call from_param(v1,ax3)
      call cat_it(v1,"fill_depth_",icom); call from_param(v1,fill_d,999999.)
      call cat_it(v1,"fill_prop_",icom); call from_param(v1,fill_v,999999.)
      
       i2=(center2-out%o2)/out%d2+1.5
       i3=(center3-out%o3)/out%d3+1.5
       ishift=1
       do while(ishift < out%n1 .and. out%layer(ishift,i2,i3)==-1)
         ishift=ishift+1
        end do 
        
        t1=ax1/out%d1
        do i1=1,t1
          p1=out%d1*(i1-1)
          scale1=1
          d1=(out%d1*(i1-1)/ax1)**2

          do i3=max(1,ceiling((center3-out%o3-scale1*ax3)/out%d3)),min(out%n3,floor((center3-out%o3+scale1*ax3)/out%d3))
            d3=((out%o3+out%d3*(i3-1)-center3)/ax3)**2
            do i2=max(ceiling((center2-scale1*ax2-out%o2)/out%d2),1),min(floor((center2-out%o2+scale1*ax2)/out%d2),out%n2)
              d2=((out%o2+out%d2*(i2-1)-center2)/ax2)**2
              if(d2+d3+d1 <1) then
                 if(p1 > fill_d .and. out%layer(i1+ishift,i2,i3)>-1) then
                   out%layer(i1+ishift,i2,i3)=icom
                   out%vals(i1+ishift,i2,i3)=fill_v
                 else if(p1 <= fill_d) then
                   if(i1+ishift >1) then
                     if(out%layer(i1+ishift-1,i2,i3)/=-1) then
                       out%layer(:i1+ishift,i2,i3)=-1
                       out%vals(:i1+ishift,i2,i3)=-1
                     end if
                   end if
                   out%layer(i1+ishift,i2,i3)=-1
                   out%vals(i1+ishift,i2,i3)=-1
                 end if
              end if
            end do
          end do
        end do
!  out%vals=out%layer
 ! ierr=srite("layer.H",out%vals,size(out%vals)*4)
  end subroutine  

  subroutine erode_river(out,icom)
    type(vel_model) :: out
    integer :: ithick,i2,i3,i1,ifound,icom,nlayer,i0,iold,imax,i3o
    character(len=256) :: tmp,v1
    real :: vel,d2u,p2,tuse,dist,fill_v
    real :: wave(3),amp(3),pos,b3,e3,b2,e2,start2,edge,dmax
    real :: angle,thick,depth,fill_d,vel_d,start3,end3,p3,w3,w2,t3,t2
    real :: d,tdepth
    
    call cat_it(v1,"cosine_wave1_",icom); call from_param(v1,wave(1))
    call cat_it(v1,"cosine_amp1_",icom); call from_param(v1,amp(1))
    call cat_it(v1,"cosine_wave2_",icom); call from_param(v1,wave(2),1.)
    call cat_it(v1,"cosine_amp2_",icom); call from_param(v1,amp(2),0.)
    call cat_it(v1,"cosine_wave3_",icom); call from_param(v1,wave(3),1.)
    call cat_it(v1,"cosine_amp3_",icom); call from_param(v1,amp(3),0.)
    call cat_it(v1,"depth_",icom); call from_param(v1,depth)
    call cat_it(v1,"fill_depth_",icom); call from_param(v1,fill_d,999999.)
    call cat_it(v1,"fill_prop_",icom); call from_param(v1,fill_v,999999.)
    call cat_it(v1,"thick_",icom); call from_param(v1,thick)
    call cat_it(v1,"angle_",icom); call from_param(v1,angle)
    call cat_it(v1,"start2_",icom); call from_param(v1,start2)
    call cat_it(v1,"start3_",icom); call from_param(v1,start3,out%o1)
    call cat_it(v1,"end3_",icom); call from_param(v1,end3,out%o3+out%d3*(out%n3-1))
    
    i2=nint((start2-out%o2)/out%d2)+1.
    i3=(start3-out%o3)/out%d3+1.5
    i3o=i3
    d2u=out%d3/cos(angle/45.*atan(1.))
    p2=start2
    p3=out%o3+out%d3*(i3-1)
    edge=thick
    do while(p3 < end3 .and. p2 > out%o2 .and. p2 < out%o2+out%d2*(out%n2-1))
      if(p3 < start3+thick/2) then
        t3=1.-cos((p3-start3)/thick*4.*atan(1.))
      else if(p3 >end3-thick/2.) then
        t3=1.-cos((end3-p3)/thick*4.*atan(1.))
      else
        t3=1
      end if
      dmax=depth*t3
      tuse=t3*thick
      b2=nint((p2-tuse/2.-out%o2)/out%d2+1.)
      e2=nint((p2+tuse/2-out%o2)/out%d2+1.)
      d=0
      i1=1
      if(b2>=1  .and. e2 <=out%n2) then
        do while(d < dmax) 
          tdepth=cos(d/dmax*atan(1.)*2.)*tuse
                b2=nint((p2-tdepth/2.-out%o2)/out%d2+1.)
      e2=nint((p2+depth/2-out%o2)/out%d2+1.)
          if(d>fill_d) then
            out%layer(i1,b2:e2,i3)=icom
            out%vals(i1,b2:e2,i3)=fill_v
          else
            out%layer(i1,b2:e2,i3)=-1
            out%vals(i1,b2:e2,i3)=-1
          end if
          d=d+out%d1
          i1=i1+1
        end do
      end if
      p3=p3+out%d3
      dist=p3-start3
      i3=i3+1
      p2=start2+d2u*(i3-i3o)+amp(1)*cos(2.*dist/wave(1)*atan(1.)*4)+ &
       amp(2)*cos(dist/wave(2)*atan(1.)*4)+amp(3)*cos(dist/wave(3)*atan(1.)*4)
  end do
    
        
     
 end subroutine
end module
    