module fault_mod
  use model_type_mod
  use sep
  implicit none
  integer :: n_m(3),n_d
  real, pointer :: myloc(:,:)
  contains
  
  
  subroutine fault_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    integer :: i2,i3,lshift,l1,l2,l3,ib
    integer :: imax
    real    :: cn1,cn2,cn3,co1,co2,co3,shift1,shift2,shift3,plane1,plane2,plane3
    real     :: p1,p2,p3
    real     :: shift_max,die_max
    real    :: shift_up,shift_left,shift_out
    real    :: major,minor,max_shift
    real    :: t1,t2,zmax,xmax,ymax,t3,zbeg,zend,azimuth,plane4
    real    :: pl1,pl2,pl3,pdenom,dist
    real    :: cs1,cs2,sn1,sn2,f,m1,m2,m3,wt_edge(41,20,20)
    real, allocatable :: shift(:,:,:,:),zax(:)
    real :: dist1,dist2,dist3
    real major_shift,minor1_shift,minor2_shift,pi
    real :: ma1,ma2,ma3,scale
    character(len=128) :: v1
    integer :: ierr,i1,iz,ix,iy,ie,bound
    real  :: t,dl1,dl2,delta,len,scale2,die_minor,dir
    
    
    pi=atan(1.)*4;
    call cat_it(v1,"plane1_",icom) ;call from_param(v1,plane1)
    call cat_it(v1,"plane2_",icom) ;call from_param(v1,plane2)
    call cat_it(v1,"plane3_",icom) ;call from_param(v1,plane3)
    call cat_it(v1,"plane_sum_",icom); call from_param(v1,plane4)
    call cat_it(v1,"old1_",icom) ;call from_param(v1,co1)
    call cat_it(v1,"old2_",icom) ;call from_param(v1,co2)
    call cat_it(v1,"old3_",icom) ;call from_param(v1,co3)
    call cat_it(v1,"new1_",icom) ;call from_param(v1,cn1)
    call cat_it(v1,"new2_",icom) ;call from_param(v1,cn2)
    call cat_it(v1,"new3_",icom) ;call from_param(v1,cn3)
    call cat_it(v1,"die_max_",icom) ;call from_param(v1,die_max)
    call cat_it(v1,"die_minor_",icom) ;call from_param(v1,die_minor)
   
   call cat_it(v1,"dir_",icom) ;call from_param(v1,dir)

    if(abs(plane1*co1+plane2*co2+plane3*co3-plane4)>2.) &
      call seperr("center old is not on plane")
    if(abs(plane1*cn1+plane2*cn2+plane3*cn3-plane4)>2.) &
      call seperr("center new is not on plane")
    if(cn1<in%o1 .or. cn1 > in%o1+in%d1*(in%n1-1)) call seperr("fault center new outside model 1")
    if(cn2<in%o3 .or. cn2 > in%o2+in%d2*(in%n2-1)) call seperr("fault center new outside model 2")
    if(cn3<in%o3 .or. cn3 > in%o3+in%d3*(in%n3-1)) call seperr("fault center new outside model 3")
    if(co1<in%o1 .or. co1 > in%o1+in%d1*(in%n1-1)) call seperr("fault center old outside model 1")
    if(co2<in%o2 .or. co2 > in%o2+in%d2*(in%n2-1)) call seperr("fault center old outside model 2")
    if(co3<in%o3 .or. co3 > in%o3+in%d3*(in%n3-1)) call seperr("fault center old outside model 3")
    m1=cn1-co1
    m2=cn2-co2
    m3=cn3-co3    
    dl1=sqrt(m1*m1+m2*m2+m3*m3)
    imax=0
    !$OMP PARALLEL DO private(i1,i2,i3,p1,p2,p3,t,scale2,pl1,pl2,pl3,ma1,ma2,ma3,dl2,len,scale,imax)
      do i3=21,in%n3-20
            p3=out%o3+out%d3*(i3-1)

      p2=in%o2+in%d2*20
      do i2=21,in%n2-20
        p1=in%o1
            !first project onto plane
            t=(p1*plane1+p2*plane2+p3*plane3)/pdenom
            if(abs(t) <die_minor) then
              scale2=(1.+cos(t/die_minor*pi))/2.
              pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3)
              !angle=acos((ma1*m1+ma2*m2+ma3*m3)/dl1*dl2)
              !!now figure out far from the center point we are along shift direction
              !len=cos(angle)*dl2
              len=abs((ma1*m1+ma2*m2+ma3*m3)/dl1)
              if(len < die_max) then
                scale=.5*(1.+cos(len/die_max*pi))*scale2*dir
                imax=max(nint(scale*m1/in%d1),imax)
              end if
             end if
             p1=in%o1+(in%n1-1)*in%d1
            !first project onto plane
            t=(p1*plane1+p2*plane2+p3*plane3)/pdenom
            if(abs(t) <die_minor) then
              scale2=(1.+cos(t/die_minor*pi))/2.
              pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3)
              !angle=acos((ma1*m1+ma2*m2+ma3*m3)/dl1*dl2)
              !!now figure out far from the center point we are along shift direction
              !len=cos(angle)*dl2
              len=abs((ma1*m1+ma2*m2+ma3*m3)/dl1)
              if(len < die_max) then
                scale=.5*(1.+cos(len/die_max*pi))*scale2*dir
                imax=max(nint(scale*m1/in%d1),imax)
              end if
             end if
        p2=p2+in%d2
      end do
    end do  
    !$OMP END PARALLEL DO
    call create_new_model(in,out,imax,imax)
    pdenom=(plane1*plane1+plane2*plane2+plane3*plane3)
    allocate(shift(3,out%n1,out%n2,out%n3))
    shift=0
   !$OMP PARALLEL DO private(i1,i2,i3,p1,p2,p3,t,scale2,ma1,ma2,ma3,dl2,len,scale)
    do i3=21,out%n3-20
      p3=out%o3+out%d3*(i3-1)
      p2=out%o2+out%d2*20
      do i2=21,out%n2-20
        p1=out%o1
        do i1=imax+1,out%n1-imax
            !first project onto plane
            t=(p1*plane1+p2*plane2+p3*plane3)/pdenom
           
            if(abs(t) <die_minor) then
              scale2=(1.+cos(t/die_minor*pi))/2.
              pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3)
              !angle=acos((ma1*m1+ma2*m2+ma3*m3)/dl1*dl2)
              !!now figure out far from the center point we are along shift direction
              !len=cos(angle)*dl2
              len=abs((ma1*m1+ma2*m2+ma3*m3)/dl1)
              if(len < die_max) then
                scale=.5*(1.+cos(len/die_max*pi))*scale2*dir
             !  if(i1==250+imax .and. i2==250) write(0,*) "CHECK DIE_MINOR",i3,len,die_max,scale

                shift(:,i1,i2,i3)=scale*(/m1,m2,m3/)
                if(p1*plane1+p2*plane2+p3*plane3-plane4>0) shift(:,i1,i2,i3)=-shift(:,i1,i2,i3)
   
              end if
             end if
             p1=p1+out%d1
         end do
        p2=p2+out%d2
      end do
    end do  
    !$OMP END PARALLEL DO
    


    !handle the simple edges
    !$OMP PARALLEL DO private(i1,i2,i3,scale)
    do i3=1,20
      scale=1.-(1.+cos(real(i3-1)/20.*pi))/2.
      do i2=21,out%n2-20
        do i1=1,out%n1
          shift(:,i1,i2,i3)=scale*shift(:,i1,i2,21)
          shift(:,i1,i2,out%n3-i3+1)=scale*shift(:,i1,i2,out%n3-20)
          
        end do
      end do
    end do
    !$OMP END PARALLEL DO

   !$OMP PARALLEL DO private(scale,i1,i2,i3)
    do i3=21,out%n3-20
      do i2=1,20
      scale=1.-(1.+cos(real(i2-1)/20.*pi))/2.
        do i1=1,out%n1
          shift(:,i1,i2,i3)=scale*shift(:,i1,21,i3)
          shift(:,i1,out%n2-i2+1,i3)=scale*shift(:,i1,out%n2-20,i3)
        end do
     end do
   end do
   !$OMP END PARALLEL DO

    do i3=1,20
      do i2=1,20
         if(i2/=1 .or. i3/=1) then
           do ib=1,20
             wt_edge(ib,i2,i3)=(i2-ib)*(i2-ib)+(i3-21)*(i3-21)
             wt_edge(ib+20,i2,i3)=(i2-21)*(i2-21)+(i3-ib)*(i3-ib)
           end do
           wt_edge(41,i2,i3)=(i2-1)*(i2-1)+(i3-1)*(i3-1)
           wt_edge(:,i2,i3)=1./wt_edge(:,i2,i3)
           scale=sum(wt_edge(:,i2,i3))
           wt_edge(:,i2,i3)=wt_edge(:,i2,i3)/scale
         else
           wt_edge(1:40,1,1)=0
           wt_edge(41,1,1)=1.
         end if
      end do
    end do
  !$OMP PARALLEL DO private(scale,i1,i2,i3)
   do i3=1,20
     do i2=1,20
       do i1=1,out%n1
         do ib=1,20
           shift(:,i1,i2,i3)=shift(:,i1,i2,i3)+wt_edge(ib,i2,i3)*shift(:,i1,i2,21)+shift(:,i1,21,i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,out%n2+1-i2,i3)=shift(:,i1,out%n2+1-i2,i3)+&
              wt_edge(ib,i2,i3)*shift(:,i1,out%n2+1-i2,21)+shift(:,i1,out%n2-20,i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,i2,out%n3+1-i3)=shift(:,i1,i2,out%n3+1-i3)+&
             wt_edge(ib,i2,i3)*shift(:,i1,i2,out%n3-20)+shift(:,i1,21,out%n3+1-i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,out%n2+1-i2,out%n3+1-i3)=shift(:,i1,out%n2+1-i2,out%n3+1-i3)+&
             wt_edge(ib,i2,i3)*shift(:,i1,out%n2+1-i2,out%n3-20)+shift(:,i1,out%n2-20,out%n3+1-i3)*wt_edge(ib+21,i2,i3)
        end do
     !   write(0,*) "CHECK SHIFT",shift(:,200,i2,i3),i2,i3
      end do
    end do
  end do  
  !$OMP END PARALLEL DO


   !APPLY THE SHIFT
    !$OMP PARALLEL DO private(i1,i2,i3,l1,l2,l3) 
    do i3=1,out%n3
      do i2=1,out%n2
        do i1=1,out%n1
          l1=max(1,min(out%n1,ib+i1-nint(shift(1,i1,i2,i3)/out%d1)))
          l2=max(1,min(in%n2,i2-nint(shift(2,i1,i2,i3)/out%d2)))
          l3=max(1,min(in%n3,i3-nint(shift(3,i1,i2,i3)/out%d3)))
          out%layer(i1,i2,i3)=in%layer(l1,l2,l3)
          out%vals(i1,i2,i3)=in%vals(l1,l2,l3)
        end do
     end do
   end do
   !$OMP END PARALLEL DO
    deallocate(shift)
  end subroutine
      subroutine fault_curve(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    integer :: i2,i3,lshift,l1,l2,l3,ib
    integer :: imax
    real    :: cn1,cn2,cn3,co1,co2,co3,shift1,shift2,shift3,plane1,plane2,plane3
    real     :: p1,p2,p3,cb1,cb2,cb3,d1,d2,d3
    real     :: shift_max,die_max
    real    :: shift_up,shift_left,shift_out
    real    :: major,minor,max_shift
    real    :: t1,t2,zmax,xmax,ymax,t3,zbeg,zend,azimuth,plane4
    real    :: pl1,pl2,pl3,pdenom,dist
    real :: delta1,delta2,delta3,deltasq1,deltasq2,deltasq3,linesum,p(3)
    integer :: ipts
    real    :: cs1,cs2,sn1,sn2,f,m1,m2,m3,wt_edge(41,20,20)
    real, allocatable :: shift(:,:,:,:),zax(:),plane(:,:,:),cur(:,:,:,:),slice1(:,:),slice2(:,:)
    real :: dist1,dist2,dist3,other1,other2,other3
    real major_shift,minor1_shift,minor2_shift,pi
    real :: ma1,ma2,ma3,scale,cl1,cl2,cl3,dshift,myd
    character(len=128) :: v1
    integer :: ierr,i1,iz,ix,iy,ie,bound,npts,ind1,ind2,ind3
    real  :: t,dl1,dl2,delta,len,scale2,die_minor,dir,dmult
    real :: ca1,ca2,ca3,val1,val2,val3,f1,alpha,length
    real :: scalep
    integer :: nt,it,nline,iline,nth,ith,n(3),i,ia,ic
    real :: o(3),d(3),dd
    real :: f2,f3
    integer, external :: omp_get_num_threads,omp_get_thread_num
    
    !$omp parallel 
    nth=omp_get_num_threads()
    !$omp end parallel
    pi=atan(1.)*4;

    call cat_it(v1,"cen_beg1_",icom) ;call from_param(v1,cb1)
    call cat_it(v1,"cen_beg2_",icom) ;call from_param(v1,cb2)
    call cat_it(v1,"cen_beg3_",icom) ;call from_param(v1,cb3)
    call cat_it(v1,"delta_line1_",icom); call from_param(v1,other1);
    call cat_it(v1,"delta_line2_",icom); call from_param(v1,other2);
    call cat_it(v1,"delta_line3_",icom); call from_param(v1,other3);
    call cat_it(v1,"delta1_",icom) ;call from_param(v1,delta1)
    call cat_it(v1,"delta2_",icom) ;call from_param(v1,delta2)
    call cat_it(v1,"delta3_",icom) ;call from_param(v1,delta3)
    call cat_it(v1,"deltasq1_",icom) ;call from_param(v1,deltasq1,0.)
    call cat_it(v1,"deltasq2_",icom) ;call from_param(v1,deltasq2,0.)
    call cat_it(v1,"deltasq3_",icom) ;call from_param(v1,deltasq3,0.)
    call cat_it(v1,"die_max_",icom) ;call from_param(v1,die_max)
    call cat_it(v1,"die_minor_",icom) ;call from_param(v1,die_minor)
    call cat_it(v1,"dir_",icom) ;call from_param(v1,dir)
    call cat_it(v1,"max_shift_",icom) ;call from_param(v1,max_shift)

    call cat_it(v1,"length_",icom); call from_param(v1,length);
      ca1=cb1;ca2=cb2; ca3=cb3
          imax=0
   nt=1000
   if(1==1) then
     ind1=0
     ind2=0
     ind3=0
     if(delta1> delta2) then
       if(delta1>delta3) then
         ind1=1
       else 
         ind3=1
       end if
     else
       if(delta2>delta3) then
          ind2=1
        else
          ind3=1
       end if
     end if
     linesum=cb1*other1+cb2*other2+cb3*other3
     o=(/in%o1,in%o2,in%o3/)
     d=(/in%d1,in%d2,in%d3/)*2.
     n=ceiling((1.*(/in%n1-1,in%n2-1,in%n3-1/)/2.))+1.
     allocate(shift(3,n(1),n(2),n(3)))
     delta=max(max(abs(delta1),abs(delta2)),abs(delta3))/min(min(d(1),d(2)),d(3))/5.
     npts=length/(delta*max(max(abs(delta1),abs(delta2)),abs(delta3)))*1.7
     dist=0
     d1=0
     d2=0
     d3=0
     nline=die_max/(max(max(other1,other2),other3)*max(max(abs(delta1),abs(delta2)),abs(delta3)))*1.7
     
     call map_fault(npts,nline,(/cb1,cb2,cb3/),(/delta1,delta2,delta3/),(/deltasq1,deltasq2,deltasq3/), &
        (/other1,other2,other3/),n,o,d,die_max,max_shift,delta,shift)

   write(0,*) "CJECLK MAX",maxval(shift),minval(shift)
   
      allocate(cur(3,n(1),n(2),n(3)))
      cur=0
      alpha=.8
      do it=1,nt

        where(abs(shift)>.001) 
            cur=shift
         end where
         if(mod(it,10)==1) then
            ierr=srite("mod.H",cur,size(cur)*4)
            write(0,*) "FINISHED",it,nt,maxval(cur),minval(cur)
        end if
         
         allocate(slice1(n(1),nth),slice2(n(1),nth))
         !$OMP PARALLEL DO default(shared) private(i3,i2,ith)
         do i3=1,n(3)
           ith=omp_get_thread_num()+1
           do i2=1,n(2)
            slice2(1,ith)=0; slice2(n(1),ith)=0
            do i=1,3
              slice1(:,ith)=cur(i,:,i2,i3)
              slice2(2:n(1)-1,ith)=slice1(2:n(1)-1,ith)+&
                alpha*(slice1(3:n(1),ith)-2*slice1(2:n(1)-1,ith)+slice1(1:n(1)-2,ith))
              where(abs(shift(i,:,i2,i3))>.001) slice2(:,ith)=shift(i,:,i2,i3)            
              call rtris(n(1),alpha,-alpha,(1.+2.*alpha),-alpha,alpha,slice2(:,ith),slice1(:,ith))
              cur(i,:,i2,i3)=slice1(:,ith)
           end do
          end do
        end do 
        !$OMP END PARALLEL DO
               where(abs(shift)>.001) 
            cur=shift
         end where
        deallocate(slice1,slice2)
        allocate(slice1(n(2),nth),slice2(n(2),nth))
        slice2(1,:)=0; slice2(n(2),:)=0
        !$OMP PARALLEL DO default(shared) private(ith,i3,i1)
         do i3=1,n(3)
           ith=omp_get_thread_num()+1
           do i1=1,n(1)
              do i=1,3
                 slice1(:,ith)=cur(i,i1,:,i3)
                 slice2(2:n(2)-1,ith)=slice1(2:n(2)-1,ith)+&
                    alpha*(slice1(3:n(2),ith)-2*slice1(2:n(2)-1,ith)+slice1(1:n(2)-2,ith))
                 where(abs(shift(i,i1,:,i3))>.001) slice2(:,ith)=shift(i,i1,:,i3)
                 call rtris(n(2),alpha,-alpha,(1.+2.*alpha),-alpha,alpha,slice2(:,ith),slice1(:,ith))
                 cur(i,i1,:,i3)=slice1(:,ith)
             end do
          end do
        end do
        !$OMP END PARALLEL DO
         where(abs(shift)>.001) 
            cur=shift
         end where
                deallocate(slice1,slice2)
        allocate(slice1(n(3),nth),slice2(n(3),nth))
        slice2=0
         !$OMP PARALLEL DO default(shared) private(i1,i2,ith)
         do i2=1,n(2)
           ith=omp_get_thread_num()+1
           do i1=1,n(1)
             do i=1,3
               slice1(:,ith)=cur(i,i1,i2,:)
               slice2(1,ith)=0; slice2(n(3),ith)=0
               slice2(2:n(3)-1,ith)=slice1(2:n(3)-1,ith)+&
                  alpha*(slice1(3:n(3),ith)-2*slice1(2:n(3)-1,ith)+slice1(1:n(3)-2,ith))
               where(abs(shift(i,i1,i2,:))>.001) slice2(:,ith)=shift(i,i1,i2,:)
               call rtris(n(3),alpha,-alpha,(1.+2.*alpha),-alpha,alpha,slice2(:,ith),slice1(:,ith))
               cur(i,i1,i2,:)=slice1(:,ith)
            end do
          end do
        end do
        !$OMP END PARALLEL DO
        deallocate(slice1,slice2)
     end do
    write(0,*) "THROUGHT 1"
              ierr=srite("shifts.H",cur,size(shift)*4)

     deallocate(shift)
     allocate(shift(3,in%n1,in%n2,in%n3))
  if(1==3) then
     do i3=1,out%n3
       do i2=1,out%n2
          shift(:,1,i2,i3)=cur(:,1,i2,i3)
          shift(:,in%n1,i2,i3)=cur(:,n(1),i2,i3)
       end do
     end do
     do i3=1,out%n3
       do i1=1,out%n1
          shift(:,i1,1,i3)=cur(:,i1,1,i3)
          shift(:,i1,in%n2,i3)=cur(:,i1,n(2),i3)
       end do
     end do  
     do i2=1,out%n2
       do i1=1,out%n1
          shift(:,i1,i2,1)=cur(:,i1,i2,1)
          shift(:,i1,i2,in%n3)=cur(:,i1,i2,n(3))
       end do
     end do    
     end if
     write(0,*) "TRHOUGH 2",n
     call create_new_model(in,out,0,0)
     

     write(0,*) "SDSD",size(shift,1),size(shift,2),size(shift,3),size(shift,4)
     do i3=2,out%n3-1
       f3=real(i3-1.)/2.+1
       ic=f3
       f3=f3-ic
       do i2=2,out%n2-1
         f2=real(i2-1.)/2.+1
         ib=f2
         f2=f2-ib
         do i1=2,out%n1-1
           f1=real(i1-1.)/2.+1
           ia=f1
           f1=f1-ia
         !  if(i3==122) write(0,*) ia,ib,ic,f1,f2,f3
           shift(:,i1,i2,i3)=(1.-f1)*(1.-f2)*(1.-f3)*cur(:,ia,ib,ic)+&
             (f1)*(1.-f2)*(1.-f3)*cur(:,ia+1,ib,ic)+&
             (1.-f1)*(f2)*(1.-f3)*cur(:,ia,ib+1,ic)+&
             (f1)*(f2)*(1.-f3)*cur(:,ia+1,ib+1,ic)+&
             (1.-f1)*(1.-f2)*(f3)*cur(:,ia,ib,ic+1)+&
             (f1)*(1.-f2)*(f3)*cur(:,ia+1,ib,ic+1)+&
             (1.-f1)*(f2)*(f3)*cur(:,ia,ib+1,ic+1)+&
             (f1)*(f2)*(f3)*cur(:,ia+1,ib+1,ic+1)
         end do
       end do
    end do
     ierr=srite("shift.H",shift,size(shift)*4)

   deallocate(cur)
     call map_fault(npts,nline,(/cb1,cb2,cb3/),(/delta1,delta2,delta3/),(/deltasq1,deltasq2,deltasq3/), &
        (/other1,other2,other3/),(/in%n1,in%n2,in%n3/),o,d/2.,die_max,max_shift,delta,shift)
     write(0,*) "pt2"
     write(0,*),out%n1,out%n2,out%n3
 !   call create_new_model(in,out,0,0);
     ib=0
     write(0,*) "PT3 ",maxval(shift)
   !APPLY THE SHIFT
    !$OMP PARALLEL DO private(i1,i2,i3,l1,l2,l3) 
    do i3=1,out%n3
      do i2=1,out%n2
        do i1=1,out%n1
          l1=max(1,min(out%n1,i1-nint(shift(1,i1,i2,i3)/out%d1)))
          l2=max(1,min(in%n2,i2-nint(shift(2,i1,i2,i3)/out%d2)))
          l3=max(1,min(in%n3,i3-nint(shift(3,i1,i2,i3)/out%d3)))
!           if(shift(1,i1,i2,i3) >50) write(0,*) "IN THE SHIFT",i1,i2,i3,l1,l2,l3

          if(l1 >0 .and. l1 <= out%n1 .and. l2 >0 .and. l2 < out%n2 .and. l3 >0 .and. l3 <= out%n3) then
            out%layer(i1,i2,i3)=in%layer(l1,l2,l3)
            out%vals(i1,i2,i3)=in%vals(l1,l2,l3)
          end if
        end do
     end do
   end do
   !$OMP END PARALLEL DO
   write(0,*) "PT1"
    deallocate(shift)
     write(0,*) "done"
   end if
   
   
   if(1==3) then
      allocate(plane(2,in%n2,in%n3))
   plane=0
   do ipts=1,npts-1
      !first calculate the plane equation from three points
      d1=delta1*in%d1+deltasq1*in%d1*in%d1*(ipts*ipts-(ipts-1)*(ipts-1))
      d2=delta2*in%d2+deltasq2*in%d2*in%d2*(ipts*ipts-(ipts-1)*(ipts-1))
      d3=delta3*in%d3+deltasq3*in%d3*in%d3*(ipts*ipts-(ipts-1)*(ipts-1))
      cl1=cb1+d1
      cl2=cb2+d2
      cl3=cb3+d3
      plane1=(cl2-cb2)*(other3-cb3)-(other2-cb2)*(cl3-cb3)
      plane2=(cl3-cb3)*(other1-cb1)-(other3-cb3)*(cl1-cb1)
      plane3=(cl1-cb1)*(other2-cb2)-(other1-cb1)*(cl2-cb2)
      plane4=(plane1*cb1+plane2*cb2+plane3*cb3)
      

      
      
      co1=cb1; co2=cb2; co3=cb3;
      dmult=dshift/sqrt(d1*d1+d2*d2+d3*d3)
      cn1=co1+d1*dmult
      cn2=co2+d2*dmult
      cn3=co3+d3*dmult
      
    if(abs(plane1*co1+plane2*co2+plane3*co3-plane4)>abs(plane4/1000.)) &
      call seperr("center old is not on plane")
    if(abs(plane1*cn1+plane2*cn2+plane3*cn3-plane4)>abs(plane4/1000.)) &
      call seperr("center new is not on plane")
    if(cn1<in%o1 .or. cn1 > in%o1+in%d1*(in%n1-1)) call seperr("fault center new outside model 1")
    if(cn2<in%o3 .or. cn2 > in%o2+in%d2*(in%n2-1)) call seperr("fault center new outside model 2")
    if(cn3<in%o3 .or. cn3 > in%o3+in%d3*(in%n3-1)) call seperr("fault center new outside model 3")
    if(co1<in%o1 .or. co1 > in%o1+in%d1*(in%n1-1)) call seperr("fault center old outside model 1")
    if(co2<in%o2 .or. co2 > in%o2+in%d2*(in%n2-1)) call seperr("fault center old outside model 2")
    if(co3<in%o3 .or. co3 > in%o3+in%d3*(in%n3-1)) call seperr("fault center old outside model 3")
    m1=cn1-co1
    m2=cn2-co2
    m3=cn3-co3    
    dl1=sqrt(m1*m1+m2*m2+m3*m3)
    co1=other1
    co2=other2
    co3=other3
        pdenom=(plane1*plane1+plane2*plane2+plane3*plane3)

    !$OMP PARALLEL DO private(i1,i2,i3,p1,p2,p3,t,scale2,pl1,pl2,pl3,ma1,ma2,ma3,dl2,len,scale,imax)
      do i3=21,in%n3-20
            p3=out%o3+out%d3*(i3-1)

      p2=in%o2+in%d2*20
      do i2=21,in%n2-20
        p1=in%o1
            !first project onto plane
            t=(p1*plane1+p2*plane2+p3*plane3)/pdenom

            if(abs(t) <die_minor) then
              scale2=(1.+cos(t/die_minor*pi))/2.
              pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3)
              !angle=acos((ma1*m1+ma2*m2+ma3*m3)/dl1*dl2)
              !!now figure out far from the center point we are along shift direction
              !len=cos(angle)*dl2
              len=abs((ma1*m1+ma2*m2+ma3*m3)/dl1)
              if(len < die_max) then
                scale=.5*(1.+cos(len/die_max*pi))*scale2*dir
                plane(1,i2,i3)=plane(1,i2,i3)+scale*m1
              end if
             end if
             p1=in%o1+(in%n1-1)*in%d1
            !first project onto plane
            t=(p1*plane1+p2*plane2+p3*plane3)/pdenom
            if(abs(t) <die_minor) then
              scale2=(1.+cos(t/die_minor*pi))/2.
              pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3)
              !angle=acos((ma1*m1+ma2*m2+ma3*m3)/dl1*dl2)
              !!now figure out far from the center point we are along shift direction
              !len=cos(angle)*dl2
              len=abs((ma1*m1+ma2*m2+ma3*m3)/dl1)
              if(len < die_max) then
                scale=.5*(1.+cos(len/die_max*pi))*scale2*dir
                plane(2,i2,i3)=plane(2,i2,i3)+scale*m1
              end if
             end if
        p2=p2+in%d2
      end do
    end do  
    !$OMP END PARALLEL DO
         cb1=cl1
     cb2=cl2
     cb3=cl3
      other1=other1+delta1*in%d1+deltasq1*in%d1*in%d1
      other2=other2+delta2*in%d2+deltasq2*in%d2*in%d2
      other1=other3+delta3*in%d3+deltasq3*in%d3*in%d3
   end do
    imax=maxval(abs(plane))/in%d1
   deallocate(plane)
   cb1=ca1
   cb2=ca2
   cb3=ca3
   other1=co1
   other2=co2
   other3=co3
    call create_new_model(in,out,imax,imax)
    pdenom=(plane1*plane1+plane2*plane2+plane3*plane3)
    allocate(shift(3,out%n1,out%n2,out%n3))
    shift=0
    do ipts=1,npts-1
      !first calculate the plane equation from three points
      d1=delta1*in%d1+deltasq1*in%d1*in%d1*(ipts*ipts-(ipts-1)*(ipts-1))
      d2=delta2*in%d2+deltasq2*in%d2*in%d2*(ipts*ipts-(ipts-1)*(ipts-1))
      d3=delta3*in%d3+deltasq3*in%d3*in%d3*(ipts*ipts-(ipts-1)*(ipts-1))
      cl1=cb1+d1
      cl2=cb2+d2
      cl3=cb3+d3
      plane1=(cl2-cb2)*(other3-cb3)-(other2-cb2)*(cl3-cb3)

      plane2=(cl3-cb3)*(other1-cb1)-(other3-cb3)*(cl1-cb1)
      plane3=(cl1-cb1)*(other2-cb2)-(other1-cb1)*(cl2-cb2)
      plane4=(plane1*cb1+plane2*cb2+plane3*cb3)
      co1=cb1; co2=cb2; co3=cb3;
      dmult=dshift/sqrt(d1*d1+d2*d2+d3*d3)
      cn1=co1+d1*dmult
      cn2=co2+d2*dmult
      cn3=co3+d3*dmult

    !$OMP PARALLEL DO private(i1,i2,i3,p1,p2,p3,t,scale2,ma1,ma2,ma3,dl2,len,scale)
    do i3=21,out%n3-20
      p3=out%o3+out%d3*(i3-1)
      p2=out%o2+out%d2*20
      do i2=21,out%n2-20
        p1=out%o1
        do i1=imax+1,out%n1-imax
            !first project onto plane
            t=(p1*plane1+p2*plane2+p3*plane3)/pdenom
           
            if(abs(t) <die_minor) then
              scale2=(1.+cos(t/die_minor*pi))/2.
              pl1=p1+plane1*t
              pl2=p2+plane2*t
              pl3=p3+plane3*t
              
              !now figure out the angle between the shift vector and point plane
              ma1=pl1-co1
              ma2=pl2-co2
              ma3=pl3-co3
              dl2=sqrt(ma1*ma1+ma2*ma2+ma3*ma3)
              !angle=acos((ma1*m1+ma2*m2+ma3*m3)/dl1*dl2)
              !!now figure out far from the center point we are along shift direction
              !len=cos(angle)*dl2
              len=abs((ma1*m1+ma2*m2+ma3*m3)/dl1)
            
              if(len < die_max) then
                scale=.5*(1.+cos(len/die_max*pi))*scale2*dir
             !  if(i1==250+imax .and. i2==250) write(0,*) "CHECK DIE_MINOR",i3,len,die_max,scale

                if(p1*plane1+p2*plane2+p3*plane3-plane4>0) then
                  shift(:,i1,i2,i3)=shift(:,i1,i2,i3)-scale*(/m1,m2,m3/)
                else
                   shift(:,i1,i2,i3)=shift(:,i1,i2,i3)+scale*(/m1,m2,m3/)
                end if
              end if
             end if
             p1=p1+out%d1
         end do
        p2=p2+out%d2
      end do
    end do  
    !$OMP END PARALLEL DO
    
             cb1=cl1
     cb2=cl2
     cb3=cl3
      other1=other1+delta1*in%d1+deltasq1*in%d1*in%d1
      other2=other2+delta2*in%d2+deltasq2*in%d2*in%d2
      other1=other3+delta3*in%d3+deltasq3*in%d3*in%d3
end do

    !handle the simple edges
    !$OMP PARALLEL DO private(i1,i2,i3,scale)
    do i3=1,20
      scale=1.-(1.+cos(real(i3-1)/20.*pi))/2.
      do i2=21,out%n2-20
        do i1=1,out%n1
          shift(:,i1,i2,i3)=scale*shift(:,i1,i2,21)
          shift(:,i1,i2,out%n3-i3+1)=scale*shift(:,i1,i2,out%n3-20)
          
        end do
      end do
    end do
    !$OMP END PARALLEL DO

   !$OMP PARALLEL DO private(scale,i1,i2,i3)
    do i3=21,out%n3-20
      do i2=1,20
      scale=1.-(1.+cos(real(i2-1)/20.*pi))/2.
        do i1=1,out%n1
          shift(:,i1,i2,i3)=scale*shift(:,i1,21,i3)
          shift(:,i1,out%n2-i2+1,i3)=scale*shift(:,i1,out%n2-20,i3)
        end do
     end do
   end do
   !$OMP END PARALLEL DO

    do i3=1,20
      do i2=1,20
         if(i2/=1 .or. i3/=1) then
           do ib=1,20
             wt_edge(ib,i2,i3)=(i2-ib)*(i2-ib)+(i3-21)*(i3-21)
             wt_edge(ib+20,i2,i3)=(i2-21)*(i2-21)+(i3-ib)*(i3-ib)
           end do
           wt_edge(41,i2,i3)=(i2-1)*(i2-1)+(i3-1)*(i3-1)
           wt_edge(:,i2,i3)=1./wt_edge(:,i2,i3)
           scale=sum(wt_edge(:,i2,i3))
           wt_edge(:,i2,i3)=wt_edge(:,i2,i3)/scale
         else
           wt_edge(1:40,1,1)=0
           wt_edge(41,1,1)=1.
         end if
      end do
    end do
  !$OMP PARALLEL DO private(scale,i1,i2,i3)
   do i3=1,20
     do i2=1,20
       do i1=1,out%n1
         do ib=1,20
           shift(:,i1,i2,i3)=shift(:,i1,i2,i3)+wt_edge(ib,i2,i3)*shift(:,i1,i2,21)+shift(:,i1,21,i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,out%n2+1-i2,i3)=shift(:,i1,out%n2+1-i2,i3)+&
              wt_edge(ib,i2,i3)*shift(:,i1,out%n2+1-i2,21)+shift(:,i1,out%n2-20,i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,i2,out%n3+1-i3)=shift(:,i1,i2,out%n3+1-i3)+&
             wt_edge(ib,i2,i3)*shift(:,i1,i2,out%n3-20)+shift(:,i1,21,out%n3+1-i3)*wt_edge(ib+21,i2,i3)
           shift(:,i1,out%n2+1-i2,out%n3+1-i3)=shift(:,i1,out%n2+1-i2,out%n3+1-i3)+&
             wt_edge(ib,i2,i3)*shift(:,i1,out%n2+1-i2,out%n3-20)+shift(:,i1,out%n2-20,out%n3+1-i3)*wt_edge(ib+21,i2,i3)
        end do
     !   write(0,*) "CHECK SHIFT",shift(:,200,i2,i3),i2,i3
      end do
    end do
  end do  
  !$OMP END PARALLEL DO
ierr=srite("shift.H",shift,size(shift)*4)

   !APPLY THE SHIFT
    !$OMP PARALLEL DO private(i1,i2,i3,l1,l2,l3) 
    do i3=1,out%n3
      do i2=1,out%n2
        do i1=1,out%n1
          l1=max(1,min(out%n1,ib+i1-nint(shift(1,i1,i2,i3)/out%d1)))
          l2=max(1,min(in%n2,i2-nint(shift(2,i1,i2,i3)/out%d2)))
          l3=max(1,min(in%n3,i3-nint(shift(3,i1,i2,i3)/out%d3)))
          out%layer(i1,i2,i3)=in%layer(l1,l2,l3)
          out%vals(i1,i2,i3)=in%vals(l1,l2,l3)
        end do
     end do
   end do
   !$OMP END PARALLEL DO
    deallocate(shift)
 end if
  end subroutine
  
  
  
  
  
  subroutine rtris( n, endl, a, b, c, endr, d, q)
integer i,        n
real q(n), d(n), a, b, c, den, endl, endr
real f(n), e(n)
e(1) = -a/endl;   f(1) = d(1)/endl
do i= 2, n-1 
        den = b+c*e(i-1);   e(i) = -a/den;   f(i) = (d(i)-c*f(i-1))/den
        end do
q(n) = (d(n)-c*f(n-1)) / (endr+c*e(n-1))
do i= n-1, 1, -1
        q(i) = e(i) * q(i+1) + f(i)
        end do
return;       
end subroutine





subroutine map_fault(npts,nline,beg_pos,delta,deltasq,plane,n,o,d,die_max,max_shift,my_delta,shift)
  !parameters
  integer :: npts,nline,n(3)
  real :: beg_pos(3),delta(3),deltasq(3),plane(3),o(3),d(3)
  real :: die_max,max_shift,my_delta
  real :: shift(:,:,:,:)
  real :: pi,dist,cb(3),val(3),length,p(3),dd,dshift(3)
  real  :: scale,scalep,f1,f2,f3,mxval,sf(3),norm(3)
  real,allocatable :: amp(:,:,:),stmp(:,:,:,:)
  integer :: ipts,ipos(3),i1,i2,i3,iline,ierr,mxloc(1)
  
  
  allocate(stmp(size(shift,1),size(shift,2),size(shift,3),size(shift,4)))

  dshift(3)=0
  pi=atan(1.)*4
  allocate(amp(n(1),n(2),n(3)))
  amp=0
  
    do ipts=1,npts
       scalep=.5*(1.+cos(1.0*(ipts-npts/2.)/(npts/2.)*pi))
       cb=beg_pos+dshift
       do iline=-nline,nline
         val=cb+iline*plane*d
         ipos=(val-o)/d
         i1=ipos(1);i2=ipos(2); i3=ipos(3)
         if(i3>0 .and. i3 < n(3)-1 .and. i2 >0 .and. i2 < n(2)-1 .and. i1 >0 .and. i1 <n(1)-1) then
           length=sqrt(sum((val-cb)*(val-cb)))/die_max           
           if(length < 1. .and. length >-1) then
          ! write(0,*) "CH",iline,ipts,i1,i2,i3
              scale=.5*(1.+cos(length*pi))
              if(amp(i1,i2,i3)<scale) then
                 amp(i1,i2,i3)=scale*scalep
                 dd=amp(i1,i2,i3)*max_shift+dist
                 p=beg_pos+iline*plane*d+(dd*delta+dd*dd*deltasq)
        !         write(0,*) "CJ",amp(i1,i2,i3),amp(i1,i2,i3)*max_shift,p(1)-val(1)
                 stmp(:,i1,i2,i3)=p-val
              end if
           end if
         end if
        end do
        dist=dist+my_delta
        dshift=dist*delta+dist*dist*deltasq
      end do
      write(0,*) "SUMN",sum(amp),maxval(amp),minval(amp)
       do i3=1,n(3)
      !   do i2=1,n(2)
           do i1=1,n(1)
             mxval=maxval(amp(i1,:,i3))
             if(mxval>.0001) then
                mxloc=maxloc(amp(i1,:,i3))
                sf=stmp(:,i1,mxloc(1),i3)
                shift(:,i1,mxloc(1),i3)=sf
                if(mxloc(1)<n(2)) then
                  shift(:,i1,mxloc(1)+1,i3)=-sf
                end if
             end if
        !    end do
          end do
        end do
        deallocate(amp,stmp)
end subroutine
        
        
        
        
         
         
     
end module
