module gauss_mod
  use sep
  use model_type_mod
  implicit none
  contains
  
  subroutine gauss_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    integer :: i3,i2,i1
    real :: d1,d2,d3,dist
    integer :: imax1,imax2,imax3,ic1,ic2,ic3
    character(len=256) :: tmp,v1
    real :: center1,center2,center3
    real :: vplus,var
    call create_new_model(in,out,0,0)
    call cat_it(v1,"center1_",icom); call from_param(v1,center1)
    call cat_it(v1,"center2_",icom); call from_param(v1,center2)
    call cat_it(v1,"center3_",icom); call from_param(v1,center3)
    call cat_it(v1,"vplus_",icom); call from_param(v1,vplus)
    call cat_it(v1,"var_",icom); call from_param(v1,var)

  
    imax1=var*9/out%d1
    imax2=var*9/out%d2
    imax3=var*9/out%d3
    ic1=(center1-out%o1)/out%d1+1.5
    ic2=(center2-out%o2)/out%d2+1.5
    ic3=(center3-out%o3)/out%d3+1.5

    do i3=max(1,ic3-imax3),min(out%n3,ic3+imax3)
      d3=(out%o3+out%d3*(i3-1)-center3)**2
      do i2=max(1,ic2-imax2),min(out%n2,ic2+imax2)
         d2=(out%o2+out%d2*(i2-1)-center2)**2
        do i1=max(1,ic1-imax1),min(out%n1,ic1+imax1)
          d1=(out%o1+out%d1*(i1-1)-center1)**2
          dist=sqrt(d1+d2+d3)
          out%vals(i1,i2,i3)=out%vals(i1,i2,i3)+vplus*exp(-.5*dist/var)
        end do
      end do
    end do
  end subroutine
 
end module
    