module inplace_mod
  use model_type_mod
  use sep
  use adj_mod
  use dottest
  use solver_reg_mod
  use cgstep_mod
  implicit none
  real,pointer :: x(:),y(:)
  
  contains
  
  
  subroutine inplace_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    real :: extent2,extent3
    character(len=128) :: v1
    real,allocatable :: pts(:,:),shift(:,:,:),smat(:,:,:),z(:),top(:,:),bot(:,:)
    real :: pos1,pos2,pos3,angle,dist,p2r,p3r,p2,p3,csa,snam,vel,sup
    real :: myt,myb
    integer :: npts_top,npts_bot
    integer :: i,i2,i3,n2,n3,ix,iy,ib,ia,idist,b1,b2,e1,e2,b3,e3,k1,k2,k3,i1,ierr
    integer :: n2s,n3s
    real :: d1,d2,d3,myd,sna

    
    call create_new_model(in,out,0,0)
    call cat_it(v1,"extent2_",icom); call from_param(v1,extent2)
    call cat_it(v1,"extent3_",icom); call from_param(v1,extent3)
    n2=extent2/out%d2
    n3=extent3/out%d3
    call cat_it(v1,"npts_top_",icom); call from_param(v1,npts_top)

    allocate(top(n2,n3),bot(n2,n3))

    allocate(pts(3,npts_top),x(npts_top),y(npts_top),z(npts_top))

    do i=1,npts_top
      call cat_it_2(v1,"pts_top_",icom,i); 
      ierr=getch(v1,"f",pts(:,i))
    end do

    x=pts(1,:)
    y=pts(2,:)
    z=pts(3,:)
  call form_surface(z,top,out%d2,out%d3)
    deallocate(pts,x,y,z);
    call cat_it(v1,"npts_bot_",icom); call from_param(v1,npts_bot)
    allocate(pts(3,npts_bot),x(npts_bot),y(npts_bot),z(npts_bot))
    do i=1,npts_bot
      call cat_it_2(v1,"pts_bot_",icom,i); 
      ierr=getch(v1,"f",pts(:,i))
      write(0,*) trim(v1),ierr,pts(:,i)
    end do
    x=pts(1,:)
    y=pts(2,:)
    z=pts(3,:)
    write(0,*) "PTS",pts(3,:),z
    call form_surface(z,bot,out%d2,out%d3) 
    deallocate(pts,x,y,z)
    call cat_it(v1,"pos2_",icom); call from_param(v1,pos2)
    call cat_it(v1,"pos3_",icom); call from_param(v1,pos3)
    call cat_it(v1,"dist_",icom); call from_param(v1,dist)
    call cat_it(v1,"angle_",icom); call from_param(v1,angle)
    call cat_it(v1,"prop_",icom); call from_param(v1,vel,4500.)

 call cat_it(v1,"shift_up_",icom); call from_param(v1,sup)
    idist=dist/min(min(out%d1,out%d2),out%d3)    
    allocate(smat(idist*2+1,idist*2+1,idist*2+1))
    smat=0
    do i3=1,idist*2+1
     d3=real((i3-idist)*(i3-idist))*out%d3*out%d3
     do i2=1,idist*2+1
       d2=real((i2-idist)*(i2-idist))*out%d2*out%d2
       do i1=1,1+2*idist
         myd=sqrt(d2+d3+real((i1-idist)*(i1-idist))*out%d1*out%d1)
         if(myd <= dist) then
           smat(i1,i2,i3)=.5*(1.+cos(myd/dist*atan(1.)*4.))*sup
         end if
       end do
     end do
    end do

   angle=angle*atan(1.)/45.
    csa=cos(angle)
    sna=sin(angle)
    allocate(shift(out%n1,out%n2,out%n3))
    shift=0

    !Now lets insert the surface in
    n2=extent2/out%d2
    n3=extent3/out%d3
    !$OMP PARALLEL DO private(i3,p3r,i2,p2r,p3,p2,ix,iy,myt,myb,ib,ia,i1,b2,e1,e2,e3,k1,k2,k3)
    do i3=1,n3
      p3r=(i3-1)*out%d3
      do i2=1,n2
        p2r=(i2-1)*out%d2
        p3=p3r*csa-p2r*sna+pos3
        p2=p2r*csa+p3r*sna+pos2
        iy=(p3-out%o3)/out%d3+1.5
        ix=(p2-out%o2)/out%d2+1.5
        myt=top(i2,i3)
        myb=bot(i2,i3)
       
      if(myb>myt+out%d1 .and. ix >0 .and. iy>0 .and. ix <= out%n2 .and. iy<=out%n3) then
        ia=(myt-out%o1)/out%d1
        ib=(myb-out%d1)/out%d1
        out%layer(ia:ib,ix,iy)=icom
        out%vals(ia:ib,ix,iy)=vel
        b2=min(idist,ix-1)
        e2=min(idist,out%n2-ix)
        b3=min(idist,iy-1)
        e3=min(idist,out%n3-iy)
        do i1=ia,ib
          b1=min(idist,i1-1)
          e1=min(idist,out%n3-i1)

          do k3=-b3,e3
            do k2=-b2,e2
              do k1=-b1,e1
                shift(k1+i1,k2+ix,k3+iy)=max(shift(k1+i1,k2+ix,k3+iy),smat(idist+k1+1,k2+idist+1,k3+idist+1))
              if(i2== 1.and. i3==1 .and. i1==ia+3) write(0,*) "SHIFT APPLY",k1,k2,k3,shift(k1+i1,k2+ix,k3+iy)

              end do
            end do
          end do
        end do 
      end if
    end do
  end do 
  !$END OMP PARALLEL DO
      write(0,*) "DjD"
      
ierr=srite("shift.H",shift,size(shift)*4)
  deallocate(smat)
  !$OMP PARALLEL DO private(i1,i2,i3,ia)
  do i3=1,out%n3
    do i2=1,out%n2
      do i1=1,out%n1
        ia=shift(i1,i2,i3)/out%d1
        if(out%layer(i1,i2,i3)/=icom .and. i1+ia<=in%n1) then
          out%vals(i1,i2,i3)=in%vals(i1+ia,i2,i3)
          out%layer(i1,i2,i3)=in%layer(i1+ia,i2,i3)
        end if
      end do
    end do
  end do
  !$OMP END PARALLEL DO
  deallocate(shift,top,bot)
end subroutine
subroutine form_surface(z,mod,d2,d3)
  real :: z(:),mod(:,:)
  real,allocatable :: dist(:)
  integer :: i2,i3
  real :: d2,d3,sm
  integer :: ipt
  allocate(dist(size(z)))
  
  write(0,*) "CHECK DEPTHS",z,size(mod,2),size(mod,1)
  do i3=1,size(mod,2)
    do i2=1,size(mod,1)
      dist=sqrt((x-d2*i2)*(x-d2*i2)+(y-d3*i3)*(y-d3*i3))
      dist=1./(dist+.001)
      sm=sum(dist)
      mod(i2,i3)=sum(z*dist)/sm
       if(mod(i2,5)==0 .and. mod(i3,5)==0) write(0,*)  i2*d2,i3*d3,mod(i2,i3)
    end do
  end do
  deallocate(dist)
    

  

end subroutine

integer function fit_poly(adj,add,mod,dat)
  real :: mod(:),dat(:)
  logical,intent(in) :: adj,add
  integer :: i1,ib,ia,i
  real :: xx,yy
  call adjnull(adj,add,mod,dat)
 
  do i1=1,size(dat)
     if(.not. adj) then
       dat(i1)=dat(i1)+mod(1)
     else
       mod(1)=dat(i1)+mod(1)
    end if
     i=0
     do ib=1,5
       yy=y(i1)**(ib-1)
       do ia=1,5
         i=i+1
         xx=x(i1)**(ia-1)
        ! write(0,*) "CHECK",xx,yy
         if(.not. adj) then
            dat(i1)=dat(i1)+xx*mod(i)*yy
         else
           mod(i)=mod(i)+dat(i1)*xx*yy
         end if
       end do
     end do
  end do
  fit_poly=0
end function


         
 integer function i_op(adj,add,mod,dat)
  real :: mod(:),dat(:)
  logical,intent(in) :: adj,add
  call adjnull(adj,add,mod,dat)
  if(.not. adj)  then
     dat=dat+mod
  else
     mod=mod+dat
  end if
  i_op=0
end function

end module