module uplift_mod
  use model_type_mod
  use sep
  implicit none
  
  contains
  
  
  subroutine uplift_it(in,out,icom)
    type(vel_model) :: in,out
    integer :: icom
    real    :: center2,center3
    integer :: i2,i3
    integer :: imax_shift,ishift
    real    :: dist,dist2,dist3,len_major,len_minor,shift,loc,pi,rotate,sn,cs
    character(len=128) :: v1,v2
    real  ::major,minor
    
    pi=atan(1.)*4;
    call cat_it(v1,"center2_",icom) ;call from_param(v1,center2)
    call cat_it(v1,"center3_",icom) ;call from_param(v1,center3)
    call cat_it(v1,"die_major_",icom) ;call from_param(v1,len_major)
    call cat_it(v1,"die_minor_",icom) ;call from_param(v1,len_minor)
    call cat_it(v1,"shift_",icom) ;call from_param(v1,shift)
    call cat_it(v1,"rotate_",icom) ;call from_param(v1,rotate)

    cs=cos(rotate/180.*pi)
    sn=sin(rotate/180.*pi)

    imax_shift=0;
    do i3=1,in%n3
      dist3=(center3-(in%o3+in%d3*(i3-1)))/len_major
      do i2=1,in%n2
        dist2=(center2-(in%o2+in%d2*(i2-1)))/len_minor
        dist=sqrt(dist2*dist2+dist3*dist3)
        if(dist < 1.) then
          loc=shift/2+(shift/2.*(cos(dist*pi)))
          if(nint(loc/in%d1)>imax_shift) imax_shift=nint(loc/in%d1);
        end if
      end do
    end do
    
    if(imax_shift==0) call seperr("max shift is 0")
    call create_new_model(in,out,imax_shift,0)
    
    
    do i3=1,in%n3
      dist3=(center3-(in%o3+in%d3*(i3-1)))
      do i2=1,in%n2
        dist2=(center2-(in%o2+in%d2*(i2-1)))
        major=(cs*dist3-sn*dist2)/len_major
        minor=(sn*dist3+cs*dist2)/len_minor
        dist=sqrt(major*major+minor*minor)
        if(dist < 1.) then
          loc=shift/2+(shift/2.*(cos(dist*pi)))
          ishift=nint(loc/in%d1)

          if(ishift>0) then
         out%layer(1+(imax_shift-ishift):(imax_shift-ishift)+in%n1,i2,i3)=in%layer(1:in%n1,i2,i3)
        !  out%layer(in%n1-(imax_shift-ishift):in%n1,i2,i3)=in%layer(in%n1,i2,i3)
         
          out%vals(1+(imax_shift-ishift):(imax_shift-ishift)+in%n1,i2,i3)=in%vals(1:in%n1,i2,i3)
          end if

      !    out%vals(out%n1-(imax_shift-ishift):out%n1,i2,i3)=in%vals(in%n1,i2,i3)

        end if
      end do
    end do
    
    
  end subroutine
  
  
end module
          
    